package test.mdb;

import javax.ejb.EJBException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;

@MessageDriven(name = "MDB_CMT_TxRequiredExample", activationConfig = { @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
        @ActivationConfigProperty(propertyName = "destination", propertyValue = "ndipiazza.pl.testing"),
        @ActivationConfigProperty(propertyName = "setupAttempts", propertyValue = "-1"),
        @ActivationConfigProperty(propertyName = "hA", propertyValue = "true"),
        @ActivationConfigProperty(propertyName = "connectorClassName", propertyValue = "org.hornetq.core.remoting.impl.netty.NettyConnectorFactory,org.hornetq.core.remoting.impl.netty.NettyConnectorFactory"),        
        @ActivationConfigProperty(propertyName = "connectionParameters", propertyValue = "host=192.168.2.4;port=5445,host=192.168.2.6;port=5445")})
public class TestMDB implements MessageDrivenBean, MessageListener
{
    MessageDrivenContext mContext = null;
    Context jndiContext = null;

    int count = 0;

    private static final long serialVersionUID = -8023536477112837766L;

    public void onMessage(Message message)
    {
        System.out.println("\n ************************* In onMessage of TestMDB : " + (++count));
    }

    public void ejbRemove() throws EJBException
    {
        mContext = null;

    }

    public void setMessageDrivenContext(MessageDrivenContext messageDrivenContext) throws EJBException
    {
        mContext = messageDrivenContext;
        try
        {
            jndiContext = new InitialContext();
        }
        catch (NamingException ne)
        {
            throw new EJBException(ne);
        }
    }
}
